Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.uima.resource.metadata
Interface ProcessingResourceMetaData

All Superinterfaces:
  Cloneable, MetaDataObject, ResourceMetaData, Serializable, XMLizable

All Known Subinterfaces:
  AnalysisEngineMetaData

    public interface ProcessingResourceMetaData

extends ResourceMetaData

Metadata that describes a "Processing" `Resource` - that is, one that reads or writes to the `CAS`.

As with all `MetaDataObject`s, a `ProcessingResourceMetaData` may or may not be modifiable. An application can find out by calling the `MetaDataObject.isModifiable()` method.

Method Summary
`Capability[]` | `getCapabilities()` Retrieves this Processing Resource's `Capabilities`.
`FsIndexCollection` | `getFsIndexCollection()` Retrieves the FS Index collection used by this Processing Resource.
`FsIndexDescription[]` | `getFsIndexes()` Retrieves the Feature Structure indexes by this Processing Resource.
`OperationalProperties` | `getOperationalProperties()` Gets this Processing Resource's `OperationalProperties`.
`TypePriorities` | `getTypePriorities()` Retrieves the Type Priorites for this Processing Resource.
`TypeSystemDescription` | `getTypeSystem()` Retrieves the Type System used by this Processing Resource.
`boolean` | `isSofaAware()` Gets whether this AE is sofa-aware.
`void` | `resolveImports()` Resolves any import declarations.
`void` | `resolveImports(ResourceManager aResourceManager)` Resolves any import declarations.
`void` | `setCapabilities(Capability[] aCapabilities)` Sets this Processing Resource's `Capabilities`.
`void` | `setFsIndexCollection(FsIndexCollection aFsIndexCollection)` Sets the Feature Structure Index collection used by this Processing Resource.
`void` | `setFsIndexes(FsIndexDescription[] aFSIndexes)` Sets the Feature Structure indexes by this Processing Resource.
`void` | `setOperationalProperties(OperationalProperties aOperationalProperties)` Sets this Processing Resource's `OperationalProperties`.
`void` | `setTypePriorities(TypePriorities aTypePriorities)` Retrieves the Type Priorites for this Processing Resource.
`void` | `setTypeSystem(TypeSystemDescription aTypeSystem)` Retrieves the Type System used by this Processing Resource.

Methods inherited from interface org.apache.uima.resource.metadata.ResourceMetaData
`getConfigurationParameterDeclarations, getConfigurationParameterSettings, getCopyright, getDescription, getName, getUUID, getVendor, getVersion, setConfigurationParameterDeclarations, setConfigurationParameterSettings, setCopyright, setDescription, setName, setUUID, setVendor, setVersion, validateConfigurationParameterSettings`

Methods inherited from interface org.apache.uima.resource.metadata.MetaDataObject
`clone, equals, getAttributeValue, getSourceUrl, getSourceUrlString, isModifiable, listAttributes, setAttributeValue, setSourceUrl`

Methods inherited from interface org.apache.uima.util.XMLizable
`buildFromXMLElement, buildFromXMLElement, toXML, toXML, toXML, toXML`

Method Detail

### getTypeSystem

    TypeSystemDescription getTypeSystem()

  Retrieves the Type System used by this Processing Resource. The Type System contains `TypeDescription`s and `FeatureDescription`s that are the inputs and/or outputs of this Resource.

  Returns:
    a description of the type system used by this Resource

### setTypeSystem

    void setTypeSystem(TypeSystemDescription aTypeSystem)

  Retrieves the Type System used by this Processing Resource. The Type System contains `TypeDescription`s and `FeatureDescription`s that are the inputs and/or outputs of this Resource.

  Parameters:
    `aTypeSystem` - a description of the type system used by this Resource.
  Throws:
    `UIMA_UnsupportedOperationException` - if this `MetaDataObject` is not modifiable.

### getTypePriorities

    TypePriorities getTypePriorities()

  Retrieves the Type Priorites for this Processing Resource. Type Priorities may be used to determine the sort order of CAS indexes - see `getFsIndexes()`.

  Returns:
    the Type Priorities for Resource

### setTypePriorities

    void setTypePriorities(TypePriorities aTypePriorities)

  Retrieves the Type Priorites for this Processing Resource. Type Priorities may be used to determine the sort order of CAS indexes - see `getFsIndexes()`.

  Parameters:
    `aTypePriorities` - the Type Priorities for this Resource

### getFsIndexCollection

    FsIndexCollection getFsIndexCollection()

  Retrieves the FS Index collection used by this Processing Resource. FS Indexes are used to iterate over annotations in the `CAS`.

  Returns:
    a description of the Feature Structure indexes used by this Resource.

### setFsIndexCollection

    void setFsIndexCollection(FsIndexCollection aFsIndexCollection)

  Sets the Feature Structure Index collection used by this Processing Resource. FS Indexes are used to iterate over annotations in the `CAS`.

  Parameters:
    `aFsIndexCollection` - a description of the Feature Structure indexes used by this Resource.
  Throws:
    `UIMA_UnsupportedOperationException` - if this `MetaDataObject` is not modifiable.

### getFsIndexes

    FsIndexDescription[] getFsIndexes()

  Retrieves the Feature Structure indexes by this Processing Resource. These are used to iterate over annotations in the `CAS`.

  NOTE: this method predates the `FsIndexCollection` object, which may define additional information (name, description, vendor, version) and import other FsIndexCollections, and provides direct access to the `FsIndexDescription` objects. To access the `FsIndexCollection` object, call `getFsIndexCollection()`.

  Returns:
    a description of the Feature Structure indexes used by this Resource.

### setFsIndexes

    void setFsIndexes(FsIndexDescription[] aFSIndexes)

  Sets the Feature Structure indexes by this Processing Resource. These are used to iterate over annotations in the `CAS`.

  NOTE: this method predates the `FsIndexCollection` object, which may define additional information (name, description, vendor, version) and import other FsIndexCollections, and provides direct access to the `FsIndexDescription` objects. To access the `FsIndexCollection` object, call `getFsIndexCollection()`.

  Parameters:
    `aFSIndexes` - a description of the Feature Structure indexes used by this Resource.
  Throws:
    `UIMA_UnsupportedOperationException` - if this `MetaDataObject` is not modifiable.

### getCapabilities

    Capability[] getCapabilities()

  Retrieves this Processing Resource's `Capabilities`. Each capability consists of a set of features or types that this Resource inputs and outputs, along with the preconditions (e.g. language or mime type) on the input Entity.

  Returns:
    an array of `Capabilities`.

### setCapabilities

    void setCapabilities(Capability[] aCapabilities)

  Sets this Processing Resource's `Capabilities`. Each capability consists of a set of features or types that this Resource inputs and outputs, along with the preconditions (e.g. language or mime type) on the input Entity.

  Parameters:
    `aCapabilities` - an array of `Capabilities`.
  Throws:
    `UIMA_UnsupportedOperationException` - if this `MetaDataObject` is not modifiable.

### getOperationalProperties

    OperationalProperties getOperationalProperties()

  Gets this Processing Resource's `OperationalProperties`. This includes information such as whether this component will modify the CAS, and whether multiple instances of this component can be run in parallel.

  Returns:
    operational properties for this component

### setOperationalProperties

    void setOperationalProperties(OperationalProperties aOperationalProperties)

  Sets this Processing Resource's `OperationalProperties`. This includes information such as whether this component will modify the CAS, and whether multiple instances of this component can be run in parallel.

  Parameters:
    `aOperationalProperties` - operational properties for this component
  Throws:
    `UIMA_UnsupportedOperationException` - if this `MetaDataObject` is not modifiable.

### resolveImports

    void resolveImports()
                        throws InvalidXMLException

  Resolves any import declarations. This includes imports of type systems, type priorities, and FS index collections. The imported types, type priorities, and FS index collections are added direclty onto their respective lists, and the import elements are deleted, so this results in a structure that is equivalent to the imported elements having been defined locally.

  Specified by:
    `resolveImports` in interface `ResourceMetaData`
  Throws:
    `InvalidXMLException` - if either the import target does not exist or is invalid

### resolveImports

    void resolveImports(ResourceManager aResourceManager)
                        throws InvalidXMLException

  Resolves any import declarations. This includes imports of type systems, type priorities, and FS index collections. The imported types, type priorities, and FS index collections are added direclty onto their respective lists, and the import elements are deleted, so this results in a structure that is equivalent to the imported elements having been defined locally.

  Specified by:
    `resolveImports` in interface `ResourceMetaData`
  Parameters:
    `aResourceManager` - the Resource Manager used to locate descriptors imported by name. For example, the path in which to locate these descriptors can be set via the `ResourceManager.setDataPath(String)` method.
  Throws:
    `InvalidXMLException` - if either the import target does not exist or is invalid

### isSofaAware

    boolean isSofaAware()

  Gets whether this AE is sofa-aware. This is a derived property that cannot be set directly. An AE is sofa-aware if and only if it declares at least one input sofa or output sofa.

  Returns:
    true if this component is sofa-aware, false if it is sofa-unaware.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008 The Apache Software Foundation. All Rights Reserved.